# x2sys_solve

Determine least-squares systematic correction from crossovers

## Synopsis

gmt x2sys_solve -C column -T TAG -E c|d|g|h|s|y|z [ COE_list.txt ] [ -V[level] ] [ -W[+u] ] [ -bi binary ] [ -di nodata[+c col] ] [ -x[[-]n] ] [ --PAR=value ]

Note: No space is allowed between the option flag and the associated arguments.

## Description

x2sys_solve will use the supplied crossover information to solve for systematic corrections that can then be applied per track to improve data quality. Seven different systematic corrections can be solved for using a least-squares approach. Note: Only one data column can be processed at the time.

## Required Arguments

COE_list.txt

  Name of file with the required crossover columns as produced by x2sys_list. NOTE: If -bi is used then the first two columns are expected to hold the integer track IDs; otherwise we expect the trailing text to hold the text string names of the two tracks. If no file is given we will read from standard input.

-T TAG

  Specify the x2sys TAG which identifies the attributes of this data type.

-C column

  Specify which data column you want to process. Needed for proper formatting of the output correction table and must match the same option used in x2sys_list when preparing the input data.

-E c|d|g|h|s|y|z

  The correction type you wish to model. Choose among the following functions f(p) , where p are the m parameters per track that we will fit simultaneously using a least squares approach. Each type implies a certain input data record format:

  c will fit f(p) = a (a constant offset); records must contain track COE, ID1, ID2.

  d will fit f(p) = a + b * d (linear drift; d is distance along track; records must contain d1, d2, COE, ID1, ID2.

  g will fit f(p) = a + b sin(y)2 (1980-1930 gravity correction); records must contain crossing latitude y, COE, ID1, ID2.

  h will fit f(p) = a + b cos(h) + c cos(2h) + d sin(h) + e sin(2h) (magnetic heading correction); h is heading at crossover; records must contain headings h1, h2, COE, ID1, ID2.

  s will fit f(p) = a * z (a unit scale correction); z is the data value at the crossover; records must contain z1, z2, ID1, ID2.

  t will fit f(p) = a + b * (t - t0) (linear drift; t - t0 is the time along the track since start of track at t0); records must contain t1-t0, t2-t0, COE, D1, ID2.

  z will fit f(p) = a + b * z (an offset plus a unit scale correction); z is the data value at the crossover; records must contain z1, z2, ID1, ID2.

## Optional Arguments

-V[level]

  Select verbosity level [w]. (See full description) (See cookbook information).

-W[+u]

  Means that each input records has an extra column just before the ID columns with the composite weight for each crossover record. These are used to obtain a weighted least squares solution [no weights]. Append +u to report unweighted mean/std [Default, report weighted stats].

-bi record[+b|l] (more …)

  Select native binary format for primary table input.

-di nodata[+c col] (more …)

  Replace input columns that equal nodata with NaN.

-x[[-]n] (more …)

  Limit number of cores used in multi-threaded algorithms (OpenMP required).

-^ or just -

  Print a short message about the syntax of the command, then exit (Note: on Windows just use -).

-+ or just +

  Print an extensive usage (help) message, including the explanation of any module-specific option (but not the GMT common options), then exit.

-? or no arguments

  Print a complete usage (help) message, including the explanation of all options, then exit.

--PAR=value

  Temporarily override a GMT default setting; repeatable. See gmt.conf for parameters.

## Notes

Most of the model corrections in -E involve a constant offset. Because crossovers are differences between values, any absolute level will cancel out and hence the constant offsets we obtain are relative to an undetermined absolute level. To obtain a solvable solution we add the constraint that the sum of all constant offsets equal zero. If the tracks form clusters in which no tracks from one cluster cross any track from another cluster then these are two independent data sets and require they own constraint equation for their offsets. We determine the number of clusters and automatically add the required constraint equations. If you need a particular reference track to have a particular offset (e.g., 0) then you can subtract the offset you found from every track correction and add in the desired offset.

## Input Format

In moving to a more robust data record definition in GMT 6, all text items are now placed after the numerical columns. For x2sys_solve, this means that whereas the ID1, ID2 track ids used to be expected in the first two columns, they are now expected at the end. Thus, you cannot use this module with crossover tables produced by an earlier GMT version without reformatting.

## Examples

To fit a simple bias offset to faa for all tracks under the MGD77 tag, try:

    gmt x2sys_list COE_data.txt -V -TMGD77 -Cfaa -Fnc > faa_coe.txt
    gmt x2sys_solve faa_coe.txt -V -TMGD77 -Cfaa -Ec > coe_table.txt

To fit a faa linear drift with time instead, try:

    gmt x2sys_list COE_data.txt -V -TMGD77 -Cfaa -FnTc > faa_coe.txt
    gmt x2sys_solve faa_coe.txt -V -TMGD77 -Cfaa -Et > coe_table.txt

To estimate heading corrections based on magnetic crossovers associated with the tag MGD77 from the file COE_data.txt, try:

    gmt x2sys_list COE_data.txt -V -TMGD77 -Cmag -Fnhc > mag_coe.txt
    gmt x2sys_solve mag_coe.txt -V -TMGD77 -Cmag -Eh > coe_table.txt

To estimate unit scale corrections based on bathymetry crossovers, try:

    gmt x2sys_list COE_data.txt -V -TMGD77 -Cdepth -Fnz > depth_coe.txt
    gmt x2sys_solve depth_coe.txt -V -TMGD77 -Cdepth -Es > coe_table.txt

## References

Wessel, P. (2010), Tools for analyzing intersecting tracks: the x2sys package. Computers and Geosciences, 36, 348-354, https://www.researchgate.net/publication/220164039_Tools_for_analyzing_intersecting_tracks_The_x2sys_package.

Wessel, P. (1989), XOVER: A cross-over error detector for track data, Computers and Geosciences, 15(3), 333-346, https://doi.org/10.1016/0098-3004(89)90044-7.

## See Also

x2sys_binlist, x2sys_cross, x2sys_datalist, x2sys_get, x2sys_init, x2sys_list, x2sys_put, x2sys_report